diff --git mscore/mscore/jackaudio.cpp mscore/mscore/jackaudio.cpp
index b6ac875..335ebce 100644
--- mscore/mscore/jackaudio.cpp
+++ mscore/mscore/jackaudio.cpp
@@ -318,16 +318,6 @@ static int graph_callback(void*)
 int JackAudio::processAudio(jack_nframes_t frames, void* p)
       {
       JackAudio* audio = (JackAudio*)p;
-      float* l;
-      float* r;
-      if (preferences.useJackAudio) {
-            l = (float*)jack_port_get_buffer(audio->ports[0], frames);
-            r = (float*)jack_port_get_buffer(audio->ports[1], frames);
-            }
-      else {
-            l = 0;
-            r = 0;
-            }
       if (preferences.useJackMidi) {
             foreach(jack_port_t* port, audio->midiOutputPorts) {
                   void* portBuffer = jack_port_get_buffer(port, frames);
@@ -364,6 +354,19 @@ int JackAudio::processAudio(jack_nframes_t frames, void* p)
                         }
                   }
             }
+      float* l;
+      float* r;
+      if (preferences.useJackAudio) {
+            l = (float*)jack_port_get_buffer(audio->ports[0], frames);
+            r = (float*)jack_port_get_buffer(audio->ports[1], frames);
+            }
+      else {
+            l = 0;
+            r = 0;
+            // Seq::process() assumes, that the frames gives the length of the
+            // the l and r buffers. Therefore we have to set it to 0.
+            frames = 0;
+            }
       audio->seq->process((unsigned)frames, l, r);
       return 0;
       }
@@ -448,7 +451,9 @@ bool JackAudio::init()
                   }
             }
 
-      if (preferences.useJackMidi) {
+      // seq::process() assumes that we have valid buffers if it is called.
+      // Therefore we activate jackMidi only, if JackAudio is activated as well.
+      if (preferences.useJackAudio && preferences.useJackMidi) {
             for (int i = 0; i < preferences.midiPorts; ++i)
                   registerPort(QString("mscore-midi-%1").arg(i+1), false, true);
             registerPort(QString("mscore-midiin-1"), true, true);
